<template>
  <div class="exercise">
    <div class="exercise-content">
      <div class="columns">
        <Column v-for="col in columns"
                :key="col.title"
                :column="col"
                :rules="productionRules"
                :terminals="terminals"
                :nonterminals="nonterminals"
                :start-variable="startVariable">
        </Column>
      </div>
    </div>
  </div>
</template>

<script>
import Column from "./Column";
import {onMounted, onUpdated, provide, ref, toRefs, watch} from "vue";
import useColumns from "../composables/useColumns";

export default {
  name: "ExerciseLayout",
  components: {
    Column
  },
  props: ['exercise'],
  setup(props) {

    const id = ref(null)
    const category = ref(null)
    const nonterminals = ref(null)
    const terminals = ref(null)
    const startVariable = ref(null)
    const productionRules = ref(null)

    const { exercise } = toRefs(props)

    const getCurrentExercise = () => {
      id.value = props.exercise.id
      category.value = props.exercise.category
      nonterminals.value = props.exercise.nonterminals
      terminals.value = props.exercise.terminals
      startVariable.value = props.exercise.startVariable
      productionRules.value = props.exercise.productionRules
    }

    onMounted(getCurrentExercise)
    watch(exercise, getCurrentExercise)

    const { columns, getColumns, unlockNextStep } = useColumns(id, productionRules, nonterminals, terminals, startVariable);


    provide('unlockNextStep', unlockNextStep)
    provide ('columns', columns)

    return {
      columns,
      productionRules,
      terminals,
      nonterminals,
      startVariable
    }
  }
}
</script>

<style>

</style>